///*
// * The MIT License (MIT)
// *
// * Copyright (c) 2013 Dries K. Aka Dries007 and the CCM modding crew.
// *
// * Permission is hereby granted, free of charge, to any person obtaining a copy of
// * this software and associated documentation files (the "Software"), to deal in
// * the Software without restriction, including without limitation the rights to
// * use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
// * the Software, and to permit persons to whom the Software is furnished to do so,
// * subject to the following conditions:
// *
// * The above copyright notice and this permission notice shall be included in all
// * copies or substantial portions of the Software.
// *
// * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
// * FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
// * COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
// * IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
// * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
// */
//
//package ccm.pay2spawn.types.guis;
//
//import ccm.pay2spawn.configurator.Configurator;
//import ccm.pay2spawn.network.TestPacket;
//import ccm.pay2spawn.random.RandomRegistry;
//import ccm.pay2spawn.random.RndSound;
//import ccm.pay2spawn.types.SoundType;
//import com.google.common.base.Strings;
//import com.google.gson.JsonObject;
//
//import javax.swing.*;
//import java.awt.*;
//import java.awt.event.ActionEvent;
//import java.awt.event.ActionListener;
//import java.util.ArrayList;
//import java.util.Collections;
//import java.util.HashMap;
//
//import static ccm.pay2spawn.types.SoundType.*;
//import static ccm.pay2spawn.util.Constants.*;
//
//public class SoundTypeGui extends HelperGuiBase
//{
//    public JScrollPane scrollPane;
//    public JPanel      panel1;
//    public JTextPane   jsonPane;
//    public JButton     parseFromJsonButton;
//    public JButton     saveButton;
//    public JButton     updateJsonButton;
//    public JButton     testButton;
//
//    public JComboBox<String> soundNameComboBox;
//    public JTextField        volumeTextField;
//    public JTextField        pitchTextField;
//    public JCheckBox         playAtEveryoneCheckBox;
//    public JTextField        HTMLTextField;
//
//    public SoundTypeGui(final int rewardID, final String name, final JsonObject inputData, final HashMap<String, String> typeMap)
//    {
//        super(rewardID, name, inputData, typeMap);
//
//        ArrayList<String> list = new ArrayList<>();
//        $$$setupUI$$$();
//        list.addAll(SoundType.all);
//        list.add(RandomRegistry.getInstanceFromClass(RndSound.class).getIdentifier());
//        Collections.sort(list);
//        soundNameComboBox.setModel(new DefaultComboBoxModel<>(list.toArray(new String[list.size()])));
//
//        makeAndOpen();
//    }
//
//    @Override
//    public void setupListeners()
//    {
//        testButton.addActionListener(new ActionListener()
//        {
//            @Override
//            public void actionPerformed(ActionEvent e)
//            {
//                updateJson();
//                TestPacket.sendToServer(name, data);
//            }
//        });
//        saveButton.addActionListener(new ActionListener()
//        {
//            @Override
//            public void actionPerformed(ActionEvent e)
//            {
//                updateJson();
//                Configurator.instance.callback(rewardID, name, data);
//                dialog.dispose();
//            }
//        });
//        parseFromJsonButton.addActionListener(new ActionListener()
//        {
//            @Override
//            public void actionPerformed(ActionEvent e)
//            {
//                try
//                {
//                    data = JSON_PARSER.parse(jsonPane.getText()).getAsJsonObject();
//                    readJson();
//                    jsonPane.setForeground(Color.black);
//                }
//                catch (Exception e1)
//                {
//                    jsonPane.setForeground(Color.red);
//                    e1.printStackTrace();
//                }
//            }
//        });
//        updateJsonButton.addActionListener(new ActionListener()
//        {
//            @Override
//            public void actionPerformed(ActionEvent e)
//            {
//                updateJson();
//            }
//        });
//    }
//
//    @Override
//    public JPanel getPanel()
//    {
//        return panel1;
//    }
//
//    @Override
//    public void readJson()
//    {
//        soundNameComboBox.setSelectedItem(readValue(SOUNDNAME_KEY, data));
//        volumeTextField.setText(readValue(VOLUME_KEY, data));
//        pitchTextField.setText(readValue(PITCH_KEY, data));
//        HTMLTextField.setText(readValue(CUSTOMHTML, data));
//
//        playAtEveryoneCheckBox.setSelected(readValue(PLAYTOALL_KEY, data).equals("1"));
//
//        jsonPane.setText(GSON.toJson(data));
//    }
//
//    @Override
//    public void updateJson()
//    {
//        storeValue(SOUNDNAME_KEY, data, soundNameComboBox.getSelectedItem());
//        storeValue(VOLUME_KEY, data, volumeTextField.getText());
//        storeValue(PITCH_KEY, data, pitchTextField.getText());
//
//        storeValue(PLAYTOALL_KEY, data, playAtEveryoneCheckBox.isSelected() ? "1" : "0");
//        if (!Strings.isNullOrEmpty(HTMLTextField.getText())) storeValue(CUSTOMHTML, data, HTMLTextField.getText());
//
//        jsonPane.setText(GSON.toJson(data));
//    }
//
//    /**
//     * Method generated by IntelliJ IDEA GUI Designer
//     * >>> IMPORTANT!! <<<
//     * DO NOT edit this method OR call it in your code!
//     *
//     * @noinspection ALL
//     */
//    private void $$$setupUI$$$()
//    {
//        panel1 = new JPanel();
//        panel1.setLayout(new BorderLayout(0, 0));
//        final JPanel panel2 = new JPanel();
//        panel2.setLayout(new GridBagLayout());
//        panel1.add(panel2, BorderLayout.CENTER);
//        final JPanel panel3 = new JPanel();
//        panel3.setLayout(new GridBagLayout());
//        GridBagConstraints gbc;
//        gbc = new GridBagConstraints();
//        gbc.gridx = 0;
//        gbc.gridy = 0;
//        gbc.weightx = 1.0;
//        gbc.fill = GridBagConstraints.BOTH;
//        panel2.add(panel3, gbc);
//        final JLabel label1 = new JLabel();
//        label1.setText("Visual editor:");
//        gbc = new GridBagConstraints();
//        gbc.gridx = 0;
//        gbc.gridy = 0;
//        gbc.anchor = GridBagConstraints.WEST;
//        panel3.add(label1, gbc);
//        final JLabel label2 = new JLabel();
//        label2.setText("Type:");
//        gbc = new GridBagConstraints();
//        gbc.gridx = 2;
//        gbc.gridy = 0;
//        panel3.add(label2, gbc);
//        final JLabel label3 = new JLabel();
//        label3.setText("SoundName:");
//        gbc = new GridBagConstraints();
//        gbc.gridx = 0;
//        gbc.gridy = 1;
//        gbc.anchor = GridBagConstraints.EAST;
//        panel3.add(label3, gbc);
//        final JLabel label4 = new JLabel();
//        label4.setText("STRING");
//        gbc = new GridBagConstraints();
//        gbc.gridx = 2;
//        gbc.gridy = 1;
//        panel3.add(label4, gbc);
//        soundNameComboBox = new JComboBox();
//        soundNameComboBox.setEditable(true);
//        soundNameComboBox.setToolTipText("Look, a build in list!");
//        gbc = new GridBagConstraints();
//        gbc.gridx = 1;
//        gbc.gridy = 1;
//        gbc.weightx = 1.0;
//        gbc.fill = GridBagConstraints.BOTH;
//        panel3.add(soundNameComboBox, gbc);
//        final JLabel label5 = new JLabel();
//        label5.setText("Volume:");
//        gbc = new GridBagConstraints();
//        gbc.gridx = 0;
//        gbc.gridy = 2;
//        gbc.anchor = GridBagConstraints.EAST;
//        panel3.add(label5, gbc);
//        final JLabel label6 = new JLabel();
//        label6.setText("FLOAT");
//        gbc = new GridBagConstraints();
//        gbc.gridx = 2;
//        gbc.gridy = 2;
//        panel3.add(label6, gbc);
//        volumeTextField = new JTextField();
//        volumeTextField.setToolTipText("Relative to 1.0");
//        gbc = new GridBagConstraints();
//        gbc.gridx = 1;
//        gbc.gridy = 2;
//        gbc.anchor = GridBagConstraints.WEST;
//        gbc.fill = GridBagConstraints.HORIZONTAL;
//        panel3.add(volumeTextField, gbc);
//        final JLabel label7 = new JLabel();
//        label7.setText("Pitch:");
//        gbc = new GridBagConstraints();
//        gbc.gridx = 0;
//        gbc.gridy = 3;
//        gbc.anchor = GridBagConstraints.EAST;
//        panel3.add(label7, gbc);
//        pitchTextField = new JTextField();
//        pitchTextField.setToolTipText("Relative to 1.0");
//        gbc = new GridBagConstraints();
//        gbc.gridx = 1;
//        gbc.gridy = 3;
//        gbc.anchor = GridBagConstraints.WEST;
//        gbc.fill = GridBagConstraints.HORIZONTAL;
//        panel3.add(pitchTextField, gbc);
//        final JLabel label8 = new JLabel();
//        label8.setText("FLOAT");
//        gbc = new GridBagConstraints();
//        gbc.gridx = 2;
//        gbc.gridy = 3;
//        panel3.add(label8, gbc);
//        playAtEveryoneCheckBox = new JCheckBox();
//        playAtEveryoneCheckBox.setHorizontalAlignment(0);
//        playAtEveryoneCheckBox.setHorizontalTextPosition(11);
//        playAtEveryoneCheckBox.setText("Play at everyone");
//        gbc = new GridBagConstraints();
//        gbc.gridx = 1;
//        gbc.gridy = 4;
//        gbc.fill = GridBagConstraints.HORIZONTAL;
//        panel3.add(playAtEveryoneCheckBox, gbc);
//        final JLabel label9 = new JLabel();
//        label9.setText("Custom HTML:");
//        gbc = new GridBagConstraints();
//        gbc.gridx = 0;
//        gbc.gridy = 5;
//        gbc.anchor = GridBagConstraints.EAST;
//        panel3.add(label9, gbc);
//        HTMLTextField = new JTextField();
//        gbc = new GridBagConstraints();
//        gbc.gridx = 1;
//        gbc.gridy = 5;
//        gbc.anchor = GridBagConstraints.WEST;
//        gbc.fill = GridBagConstraints.HORIZONTAL;
//        panel3.add(HTMLTextField, gbc);
//        final JLabel label10 = new JLabel();
//        label10.setText("STRING");
//        gbc = new GridBagConstraints();
//        gbc.gridx = 2;
//        gbc.gridy = 5;
//        gbc.anchor = GridBagConstraints.WEST;
//        panel3.add(label10, gbc);
//        final JPanel panel4 = new JPanel();
//        panel4.setLayout(new GridBagLayout());
//        gbc = new GridBagConstraints();
//        gbc.gridx = 0;
//        gbc.gridy = 1;
//        gbc.weightx = 1.0;
//        gbc.weighty = 1.0;
//        gbc.fill = GridBagConstraints.BOTH;
//        panel2.add(panel4, gbc);
//        final JLabel label11 = new JLabel();
//        label11.setText("Json:");
//        gbc = new GridBagConstraints();
//        gbc.gridx = 0;
//        gbc.gridy = 0;
//        gbc.anchor = GridBagConstraints.WEST;
//        panel4.add(label11, gbc);
//        scrollPane = new JScrollPane();
//        gbc = new GridBagConstraints();
//        gbc.gridx = 0;
//        gbc.gridy = 1;
//        gbc.weightx = 1.0;
//        gbc.weighty = 1.0;
//        gbc.fill = GridBagConstraints.BOTH;
//        panel4.add(scrollPane, gbc);
//        jsonPane = new JTextPane();
//        jsonPane.setEnabled(true);
//        jsonPane.setText("");
//        jsonPane.setToolTipText("Make sure you hit \"Parse from JSON\" after editing this!");
//        scrollPane.setViewportView(jsonPane);
//        final JPanel panel5 = new JPanel();
//        panel5.setLayout(new GridBagLayout());
//        gbc = new GridBagConstraints();
//        gbc.gridx = 0;
//        gbc.gridy = 2;
//        gbc.weightx = 1.0;
//        gbc.fill = GridBagConstraints.BOTH;
//        panel2.add(panel5, gbc);
//        parseFromJsonButton = new JButton();
//        parseFromJsonButton.setText("Parse from Json");
//        parseFromJsonButton.setToolTipText("Push the button!");
//        gbc = new GridBagConstraints();
//        gbc.gridx = 0;
//        gbc.gridy = 0;
//        gbc.weightx = 1.0;
//        gbc.fill = GridBagConstraints.HORIZONTAL;
//        panel5.add(parseFromJsonButton, gbc);
//        saveButton = new JButton();
//        saveButton.setText("Save");
//        saveButton.setToolTipText("Push the button!");
//        gbc = new GridBagConstraints();
//        gbc.gridx = 3;
//        gbc.gridy = 0;
//        gbc.weightx = 1.0;
//        gbc.fill = GridBagConstraints.HORIZONTAL;
//        panel5.add(saveButton, gbc);
//        updateJsonButton = new JButton();
//        updateJsonButton.setText("Update Json");
//        updateJsonButton.setToolTipText("Push the button!");
//        gbc = new GridBagConstraints();
//        gbc.gridx = 1;
//        gbc.gridy = 0;
//        gbc.weightx = 1.0;
//        gbc.fill = GridBagConstraints.HORIZONTAL;
//        panel5.add(updateJsonButton, gbc);
//        testButton = new JButton();
//        testButton.setText("Test");
//        testButton.setToolTipText("Push the button!");
//        gbc = new GridBagConstraints();
//        gbc.gridx = 2;
//        gbc.gridy = 0;
//        gbc.weightx = 1.0;
//        gbc.fill = GridBagConstraints.HORIZONTAL;
//        panel5.add(testButton, gbc);
//        label3.setLabelFor(soundNameComboBox);
//        label5.setLabelFor(volumeTextField);
//        label7.setLabelFor(pitchTextField);
//    }
//
//    /**
//     * @noinspection ALL
//     */
//    public JComponent $$$getRootComponent$$$()
//    { return panel1; }
//}
